int Pass;
Pass = 1;
# Pass 0 demonstrates the Capture or Reference Bitmpas using CROP()
# Pass 1 demonstrates a method for locating the coordinates for all open switches.

if(Pass == 0){
# This is actual output from "ViewIt"
# Unfortunately, because we are running from an already
# captured bitmap, we can't run this as a live function.
#function void Generate(window w){
#	w.SetActive();
#	bitmap b = w.CaptureBitmap();
# Added code to "fix" running not-live
	bool BinRet;
 	bitmap b;
	BinRet = b.Load("Switches_Tabs_0.bmp");

	bitmap f;
#
	f = b;
	f.Crop(9,302,50,11);
	f.Save("Switch_Tab_0.bmp");
# These commented out lines are informational lines from "ViewIt"
# Which can be used to find the center of where to MouseClick()	
# Start: X,Y  9, 26  Center: X,Y  34, 31.5
#
	f = b;
	f.Crop(71,301,59,11);
	f.Save("Switch_Tab_1.bmp");
# Start: X,Y  71, 27  Center: X,Y  100.5, 32.5
#
	f = b;
	f.Crop(143,301,53,11);
	f.Save("Switch_Tab_2.bmp");
# Start: X,Y  143, 27  Center: X,Y  169.5, 32.5
#
	f = b;
	f.Crop(209,301,53,11);
	f.Save("Switch_Tab_3.bmp");
# Start: X,Y  209, 27  Center: X,Y  235.5, 32.5
#
	f = b;
	f.Crop(275,301,53,11);
	f.Save("Switch_Tab_4.bmp");
# Start: X,Y  275, 27  Center: X,Y  301.5, 32.5
#
	f = b;
	f.Crop(341,301,53,11);
	f.Save("Switch_Tab_5.bmp");
# Start: X,Y  341, 27  Center: X,Y  367.5, 32.5
#
	f = b;
	f.Crop(20,321,82,11);
	f.Save("Switch_Tab_6.bmp");
# Start: X,Y  20, 7  Center: X,Y  61, 12.5
#
	f = b;
	f.Crop(115,321,62,11);
	f.Save("Switch_Tab_7.bmp");
# Start: X,Y  115, 7  Center: X,Y  146, 12.5
#
	f = b;
	f.Crop(191,321,62,11);
	f.Save("Switch_Tab_8.bmp");
# Start: X,Y  191, 7  Center: X,Y  222, 12.5
#
	f = b;
	f.Crop(265,320,37,12);
	f.Save("Switch_Tab_9.bmp");
# Start: X,Y  265, 7  Center: X,Y  283.5, 13
#
	f = b;
	f.Crop(314,320,36,12);
	f.Save("Switch_Tab_10.bmp");
# Start: X,Y  314, 7  Center: X,Y  332, 13
#
# Might as well Capture an "Open Switch" while we're at it.
# Note: I turned Auto Increment Off in "ViewIt" for this save.
	f = b;
	f.Crop(26,251,37,22);
	f.Save("Switch_Open.bmp");
# Start: X,Y  26, 66  Center: X,Y  44.5, 77
#
#}
exit;
}

if(Pass==1){
bool BitRet;
bitmap Switch0;
bitmap SwitchDual;
BitRet = Switch0.Load("Switches_Tabs_0.bmp");
BitRet = SwitchDual.Load("Switch_Open.bmp");

int xInc = SwitchDual.GetWidth()/2;
int yInc = SwitchDual.GetHeight()/2;
# The increment valuse can be manually set all we're trying to do here is prevent
# duplicates.
int xLim = Switch0.GetWidth();
int yLim = Switch0.GetHeight();
# The Limit Values can be set manually. You really don't want to be searching outside
# of your actual bitmap. They can be lowered to only the area iod interest to speed 
# things up a bit.
int x;
int y;

while(y <= yLim){
	BitRet = Switch0.Find(x,y,SwitchDual);
	if(BitRet){
		disp(string(x) + "," + string(y));
	}

	x = x + xInc;
	if(x >= xLim){
		x = 0;
		y = y + yInc;
	}
}
# Note: You are building the output table from the Bottom Up and Left To Right
# You can use "ViewIt" to verify the Coordinates.
# Also, when doing something like switch selection adding 5 or so to both x & y values
# will help ensure you aren't clicking on a boundary.
exit;
}

if(Pass == 2){
# This is how you would load you reference Bit Maps
	string gName = "Switch_Tab_"
	bitmap gArray;
	for(int i = 0; i <= 10; i++){
		bitmap b;
		b.Load(gName + string(i) + ".bmp");
		gArray[i] = b;
	}
exit;	
}
# If we had a "Live" window then we could actually show you the Selection Process.
# Basically it works like this: FIND() the appropriate previously loaded reference 
# bitmap and then if it returns "true" (it was found) do a MouseClick at the 
# Returned x,y coordinates

# Yes, you can MouseClick() the Switches. However, they toggle and PTD can't "see" 
# what state the switches are in.So, you either turn them all off everythime and then
# turn all the desired ones on one by one. Or, figure out what the state of the one you
# want off or on and then toggle as required.

# How about Text recognition for displays that an't be "read" by PTD?
# Yep, that's coming, too!
